/* START OF tickbox.c ----------------------------------------------------------
 *
 *	A Radio Button (is actually the TickBox really).
 *
 *	---
 *	Written by David Eggleston (2006) <deggleston@users.sourceforge.net>
 *	for the 'BeebEm' Acorn BBC Model B, Integra-B, Model B Plus and
 *	Master 128 emulator.
 *
 *	This file is part of 'Economy GUI' and may be copied only under the
 *	terms of either the GNU General Public License (GPL) or Dr. David
 *	Alan Gilbert's BeebEm license.
 *
 *	For more details please visit:
 *
 *	http://www.gnu.org/copyleft/gpl.html
 *	---
 */

#if HAVE_CONFIG_H
#       include <config.h>
#endif

#include "include/log.h"

#include "include/gui_functions.h"

#include "include/gui_radiobutton.h"
#include "include/gui_radiobutton_private.h"

#include "include/gui_window.h"
#include "include/gui_window_private.h"

#include "include/gui_widget.h"
#include "include/gui_widget_private.h"

#include <SDL.h>

EG_Widget* EG_RadioButton_Create(const char *name_ptr, SDL_Color color
 , const char *caption_ptr, SDL_Rect dimension)
{
	EG_Widget *widget_ptr;

	if ( (widget_ptr = EG_TickBox_Create(name_ptr, color, caption_ptr
	 , dimension)) != NULL)
		EG_TickBox_SetIcons(widget_ptr, 13, 12);

	return(widget_ptr);
}



