/* START OF slidebar.h ----------------------------------------------------------
 *
 *	A slide bar widget.
 *
 *	---
 *	Written by David Eggleston (2006) <deggleston@users.sourceforge.net>
 *	for the 'BeebEm' Acorn BBC Model B, Integra-B, Model B Plus and
 *	Master 128 emulator.
 *
 *	This file is part of 'Economy GUI' and may be copied only under the
 *	terms of either the GNU General Public License (GPL) or Dr. David
 *	Alan Gilbert's BeebEm license.
 *
 *	For more details please visit:
 *
 *	http://www.gnu.org/copyleft/gpl.html
 *	---
 */


#ifndef _DW_SLIDEBAR_H_
#define _DW_SLIDEBAR_H_


#if HAVE_CONFIG_H
#	include <config.h>
#endif

#include "include/types.h"

#include "include/gui_widget.h"
#include "include/gui_window.h"

#include <SDL.h>


/* Widget type:
 */
#define EG_Widget_Type_SlideBar 0x0


/* Public functions:
 */

#ifdef __cplusplus
extern "C"{
#endif
	EG_Widget*	EG_SlideBar_Create(const char *name_ptr);
#ifdef __cplusplus
}
#endif

#define EG_SlideBar_Destroy				EG_Widget_CallDestroy
#define EG_SlideBar_GetID				EG_Widget_GetID
#define EG_SlideBar_GetName				EG_Widget_GetName

/* END OF slidebar.h ------------------------------------------------------------
 */
#endif

