/****************************************************************************/
/*                               Beebem                                     */
/*                               ------                                     */
/* This program may be distributed freely within the following restrictions:*/
/*                                                                          */
/* 1) You may not charge for this program or for any part of it.            */
/* 2) This copyright message must be distributed with all copies.           */
/* 3) This program must be distributed complete with source code.  Binary   */
/*    only distribution is not permitted.                                   */
/* 4) The author offers no warrenties, or guarentees etc. - you use it at   */
/*    your own risk.  If it messes something up or destroys your computer   */
/*    thats YOUR problem.                                                   */
/* 5) You may use small sections of code from this program in your own      */
/*    applications - but you must acknowledge its use.  If you plan to use  */
/*    large sections then please ask the author.                            */
/*                                                                          */
/* If you do not agree with any of the above then please do not use this    */
/* program.                                                                 */
/****************************************************************************/
/* Mike Wyatt and NRM's port to win32 - 7/6/97 */


/*
beebem 0.0.7:
-------------

Econet support (untested).
Support for $HOME/.beebem
Support for SASI/SCSI in $HOME/.beebem
Support for roms folder in $HOME/.beebem (manual copy only)
Make file updated, make uninstall added
Can now install as root (at own risk!)



The cursor IS off by two pixels, look at the teletext screenshot.





beebem 0.0.8:
-------------


a]	Very basic (innitial) msgbox support (no icon just text).
b]	Slide bar
c]	List box
d]	File selector
e]	Some basic documentation to get people started.

10)	File selector:
		a)	Slidebar.
		b)	List-box.
		c)	dir reading functions.
		d)	zip/gzip compression support.
		e)	sorting.
		f)	file selector dialog.


i]	Track&fix video bug that courses Teletext rendering to start on scanline
	-2 (the memory leak).



Other stuff:
============

00)	Make sure unchanged scanlines are not redrawn, this should be
	optional (things like GEM will benefit).
01)	Fix all warnings.
05)	Better keyboard mapping: Create spreadsheet and map all keys correctly, look at ver 0.9
09)	Go through 0.9's X11 key list and see if you've missed anything else.
12)	Test Speech.
13)	Finish file selector (+ remove dependancy for GTK).
14)	Image widget (needs to be scalable).
15)	Serial + tape support (threading).
20)	(What else goes in devices?)
21)	Make sure current fullscreen support is for X11 - others need to re-init SDL (especially XBox).
25)	User keyboard dialog? (to be determined).
26)	Debugging dialog? (to be determined).
27)	Better scaling/depth support for video emulation (to be determined).
28)	Fix design issues with GUI (to be determined).
29)	Add bitmapped widgets + image support (for the Beeb menu background).
30)	Clean-up MFC emulation.
31)	Vertical screen position in Castle Quest, is this a bug?
32)	EG_Widget pointer is NULL.
35)	Moton blur?
37)	Installing/Building documentation.
38)	Update website for offical production release.
40)	Message box dialog.
42)	Search for and fix any outstanding FIX-MEs or TODOs.
44)	Better support within UI for switching FDC.
46)	Give output messages (debug, error, warning etc) a once over.
47)	Make sure all output goes through log.
48)	Make sure everything is using log.c
49)	Fix i86 support: Can't, thoses files just will not work seperately.  Investigate.
50)	Tape/Serial support.
51)	Improve on that crappy FPS on-screen monitor.. (If time).
*/

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include "include/test.h"

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <SDL.h>


#include <iostream>
#include <fstream>
#include "include/windows.h"

#include "include/6502core.h"
#include "include/beebmem.h"
#include "include/beebsound.h"
#include "include/sysvia.h"
#include "include/uservia.h"
#include "include/beebwin.h"
#include "include/disc8271.h"
#include "include/video.h"
#include "include/via.h"
#include "include/atodconv.h"
#include "include/disc1770.h"
#include "include/serial.h"
#include "include/tube.h"
#include "include/econet.h"	//Rob

#include "include/scsi.h"	// Dave: Needed for reset on break
#include "include/sasi.h"

#include "include/i86.h"
#include "include/teletext.h"
#include "include/z80mem.h"
#include "include/z80.h"

#include "include/line.h"	// SDL Stuff
#include "include/log.h"
#include "include/sdl.h"

#include "include/gui.h"

#include "include/beebem_pages.h"
#include "include/fake_registry.h"

#ifdef MULTITHREAD
#undef MULTITHREAD
#endif

/* Make global reference to command line args
 */
int __argc = 0;
char **__argv = NULL;

/* This needs to be fixed.. ----
 */
int Tmp_Command_Line_Fullscreen=0;
/* -----------------------------
 */


extern int TorchTube;
extern int Enable_Z80;
extern VIAState SysVIAState;
int DumpAfterEach=0;

unsigned char MachineType;
BeebWin *mainWin = NULL;

void i86_main(void);

//-- HINSTANCE hInst;
//-- HWND hCurrentDialog = NULL;

//-- DWORD iSerialThread,iStatThread; // Thread IDs
FILE *tlog;


//----------------------------------------------

int done = 0;
int fullscreen = 0;
int showing_menu = 0;
EG_Window *displayed_window_ptr = NULL;


//void CLEAN_EXIT(void)
//{
//  /* Quit SDL
//   */
//  SDL_Quit();
//}


void SetActiveWindow(EG_Window *window_ptr)
{
	displayed_window_ptr = window_ptr;
}

int GetFullscreenState(void)
{
	return(fullscreen);
}

int ToggleFullscreen(void)
{
	if (fullscreen != 0)
		fullscreen = 0;
	else
		fullscreen = 1;

	if (SDL_WM_ToggleFullScreen(screen_ptr) != 1)
		EG_Log(EG_LOG_WARNING, dL"Could not toggle full-screen mode.", dR);

	return(fullscreen);
}

void UnfullscreenBeforeExit(void)
{
	/* Hopefully this will fix that annoying bug where the mouse pointer
	 * vanishes on exit.  Is that me, or is it SDL?
	 */
	if (fullscreen)
		ToggleFullscreen();
}

void ShowingMenu(void)
{
	showing_menu = 1;
}

void NoMenuShown(void)
{
	showing_menu = 0;
}

void Quit(void)
{
	done=1;
}



//------------------------------------------------

//-- int CALLBACK WinMain(HINSTANCE hInstance, 
//-- 					HINSTANCE hPrevInstance,
//-- 					LPSTR lpszCmdLine,
//-- 					int nCmdShow)
//-- { 
int main(int argc, char *argv[]){
//--	MSG msg;

	//printf("%d\n", testingit(1, 2, 3));

//+>
	int X11_CapsLock_Down;
	Uint32 ticks=SDL_GetTicks();
//	int mouse_x=0, mouse_y=0, mouse_move_x, mouse_move_y;
//	BOOL ignore_next_mouse_movement = FALSE;
//	int buttons=0;
//<+

//--	hInst = hInstance;

	/* Create global reference to command line args (like windows does)
	 */
	__argc = argc;
	__argv = (char**) argv;

	

	/* Initialise debugging subsystem.
	 */
	Log_Init();

	/* Initialize SDL resources.
	 */
	if (! InitialiseSDL(argc, argv)){
		qFATAL("Unable to initialise SDL library!");
		exit(1);
	}

/* Initialize GUI API
 */
	if (EG_Initialize() == EG_TRUE){
		qINFO("EG initialized");
	}else{
		qFATAL("EG FAILED TO INITIALIZE");
		exit(1);
	}

	/* Build menus:
	*/
	if (InitializeBeebEmGUI(screen_ptr) != EG_TRUE)
		exit(1);

	/* Initialize fake windows registry:
	 */
	InitializeFakeRegistry();


	  /* Clean-up at exit
  	 */
//  	atexit(CLEAN_EXIT);

	/* ---------------------------------------
	 */

	mainWin=new BeebWin();
	mainWin->Initialise();

	/* ------------------------------------------------------
	 */

	//EG_Draw_SetToLowResolution();

	// Create serial threads
//--	InitThreads();
//--	CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) SerialThread,NULL,0,&iSerialThread);
//--	CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) StatThread,NULL,0,&iStatThread);

	/* -------------------------------------------------0----------
	 */

//    tlog = fopen("\\trace.log", "wt");


	/* Clear SDL event queue
	 */
	EG_Draw_FlushEventQueue();






































	/* Main loop converted to SDL:
	 */
	X11_CapsLock_Down = 0;	// =0 not down, used to emulate a key release in X11 (caps has no release event).

	pDEBUG(dL"Got to main loop!", dR);
	done = 0; do{

//--		if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) || mainWin->IsFrozen())
//--		{
//--			if(!GetMessage(&msg,    // message structure
//--							NULL,   // handle of window receiving the message
//--							0,      // lowest message to examine
//--							0))
//--				break;              // Quit the app on WM_QUIT
//--  
//--			if (hCurrentDialog == NULL || !IsDialogMessage(hCurrentDialog, &msg)) {
//--				TranslateMessage(&msg);// Translates virtual key codes
//--				DispatchMessage(&msg); // Dispatches message to window
//--			}
//--		}

		/* As X11 sucks, we need to release the Caps Lock key ourselves, an event will not happen.
		 * The X11_CapsLock_Down var basically counts down once per pass of the emulator core, when
		 * it's 1, we assume enough time has passed to pass the core a release of the Beebs Caps Lock
		 * key.
		 */
		if (X11_CapsLock_Down>0){
			X11_CapsLock_Down--;
			if (X11_CapsLock_Down == 0)
				BeebKeyUp(4, 0);
		}
		


		/* Toggle processing of either events to the emulator core, or events to the menu.
		 */
		SDL_Event event;

		if (showing_menu != 1){

		/* Execute emulator:
		 */
		if (!mainWin->IsFrozen())
			Exec6502Instruction();

		/* If the mouse cursor should be hidden (set on GUI),
		 * then make sure it is hidden after a suitable delay.
		 * (Delay is set in the menu event code below) 
		 */
		if (mainWin->CursorShouldBeHidden()
		 && SDL_ShowCursor(SDL_QUERY) == SDL_ENABLE
		 && EG_Draw_CalcTimePassed(ticks
		 , SDL_GetTicks()) >= 2500)
			SDL_ShowCursor(SDL_DISABLE);

		while (SDL_PollEvent(&event))
			switch (event.type)
			{
			case SDL_QUIT:
				done=1;
			break;


			case SDL_MOUSEMOTION:
//			if (event.type == SDL_MOUSEMOTION){
				if (mainWin)
				{
//--                            mainWin->ScaleMousestick(LOWORD(lParam), HIWORD(lParam));
//--                            mainWin->SetAMXPosition(LOWORD(lParam), HIWORD(lParam));

				mainWin->ScaleMousestick( (unsigned int) event.motion.x
				 , (unsigned int) event.motion.y );
				mainWin->SetAMXPosition( (unsigned int) event.motion.x
				 , (unsigned int) event.motion.y );

					// Experiment: show menu in full screen when cursor moved to top of window
					//-- if (HideMenuEnabled)
					//-- {
					//-- 	if (HIWORD(lParam) <= 2)
					//-- 		mainWin->ShowMenu(true);
					//-- 	else
					//-- 		mainWin->ShowMenu(false); 
					//-- }
				}
//			}
			break;




			case SDL_MOUSEBUTTONDOWN:

//			if (event.type == SDL_MOUSEBUTTONDOWN){
			//-- case WM_LBUTTONDOWN:
				if (event.button.button == SDL_BUTTON_LEFT){
//					printf("left button down\n");
//--					if (mainWin) mainWin->SetMousestickButton(TRUE);
					AMXButtons |= AMX_LEFT_BUTTON;
				}
			//-- case WM_MBUTTONDOWN:
				if (event.button.button == SDL_BUTTON_MIDDLE){
//					printf("middle button down\n");
					AMXButtons |= AMX_MIDDLE_BUTTON;
				}
			//-- case WM_RBUTTONDOWN:
				if (event.button.button == SDL_BUTTON_RIGHT){
//				 	printf("right button down\n");
					AMXButtons |= AMX_RIGHT_BUTTON;
				}
//			}

			break;


			case SDL_MOUSEBUTTONUP:

//				if (ignore_next_mouse_movement == TRUE){
//					ignore_next_mouse_movement = FALSE;
//					break;
//				}else{
//					ignore_next_mouse_movement = TRUE;
//					SDL_WarpMouse(SDL_WINDOW_WIDTH/2, SDL_WINDOW_HEIGHT/2);
//				}
//
//				mouse_move_x = event.motion.x - SDL_WINDOW_WIDTH/2;
//				mouse_move_y = event.motion.y - SDL_WINDOW_HEIGHT/2;
//
//				if (mouse_move_x > 1) mouse_move_x /4;
//				if (mouse_move_y > 1) mouse_move_y /4;
//
//				mouse_x += mouse_move_x;
//				mouse_y += mouse_move_y;
//
//				//mouse_x = mouse_x + (event.motion.x - SDL_WINDOW_WIDTH/2);
//				//mouse_y = mouse_y + (event.motion.y - SDL_WINDOW_HEIGHT/2);
//
//				if (mouse_x>=SDL_WINDOW_WIDTH*2) mouse_x = SDL_WINDOW_WIDTH*2;
//				if (mouse_x<0-SDL_WINDOW_WIDTH) mouse_x = 0-0-SDL_WINDOW_WIDTH;
//				if (mouse_y>=SDL_WINDOW_HEIGHT*2) mouse_y = SDL_WINDOW_HEIGHT*2;
//				if (mouse_y<0-SDL_WINDOW_HEIGHT) mouse_y = 0-SDL_WINDOW_HEIGHT;
//
//				printf("SDL xrel = %d, SDL yrel = %d\n", mouse_x, mouse_y);
				
//				if (event.type == SDL_MOUSEMOTION){ 
//					mouse_x = event.motion.x;
//					mouse_y = event.motion.y;
//				}else{
//					mouse_x = event.button.x;
//					mouse_y = event.button.y;
//				}



//			if (event.type == SDL_MOUSEBUTTONUP){
			//-- case WM_LBUTTONUP:
				if (event.button.button == SDL_BUTTON_LEFT){
//					printf("left button up\n");
//--					if (mainWin) mainWin->SetMousestickButton(FALSE);
					AMXButtons &= ~AMX_LEFT_BUTTON;
				}
			//-- case WM_MBUTTONUP:
				if (event.button.button == SDL_BUTTON_MIDDLE){
//					printf("middle button up\n");
					AMXButtons &= ~AMX_MIDDLE_BUTTON;
				}
			//-- case WM_RBUTTONUP:
				if (event.button.button == SDL_BUTTON_RIGHT){
//					printf("right button up\n");
					AMXButtons &= ~AMX_RIGHT_BUTTON;
				}
//			}

//			AMXButtons = buttons;
			break;

			case SDL_KEYDOWN:
			case SDL_KEYUP:
				{
					int pressed=0, col=0, row=0;
			

					if (event.key.keysym.sym == SDLK_MENU)
						Show_Main();

					if (event.key.keysym.sym == SDLK_F12){
//						printf("f12\n");
						Show_Main();
					}

					
/*

	if(event.key.keysym.sym == SDLK_F11)
	{

	// Max width is 480 - image width - 2 letters.
	// Box will size to number of horizontal characters and vertical lines.
	// (Need to think about what will happen with a proportional font.
	// Buttons are provided (upto four), you can also specify which has focus.
	// Images are: Information, Exclamation, Critical, Question.
 

	EG_Window *dialog = EG_Window_Create("Dialog", screen_ptr, (SDL_Color) {255-64, 0, 0, 0}, (SDL_Rect) {100,100,100,100});

	EG_Widget *button1 = EG_Button_Create("button1", (SDL_Color) {255-64, 0,0,0}, 0, "Not OK", (SDL_Rect) {10,70,80,20});

	
	EG_Window_AddWidget(dialog, button1);


	EG_Window_Show(dialog);

	if (SDL_ShowCursor(SDL_QUERY) != SDL_ENABLE) SDL_ShowCursor(SDL_ENABLE);

	// Process window manager signals:
	int d=0;
	SDL_Event e;
	while(!d){
		while ( SDL_PollEvent(&e) ){
			switch (e.type) {
				case SDL_QUIT:
                        	d=1;
                        	break;

#                       	ifdef WITH_DEBUG_OUTPUT
                        	case SDL_KEYDOWN:
                        	if(e.key.keysym.sym == SDLK_ESCAPE)
                        		d=1;
                        	break;
#                       	endif
			}
			EG_Window_ProcessEvent(dialog, &e, 0, 0);
		}
        	SDL_Delay(50);
	}

	EG_Window_DestroyAllChildWidgets(dialog);
	EG_Window_Destroy(dialog);

	}



*/















					//if (event.key.keysym.sym == SDLK_END)
					//	done=1;

					pressed = col = row = 0;

					/* Handle shift booting:
					 */
					if (mainWin->m_ShiftBooted){
						mainWin->m_ShiftBooted = false;
						BeebKeyUp(0, 0);
					}

					/* Convert SDL key press into BBC key press:
					 */
					if (ConvertSDLKeyToBBCKey(event.key.keysym /*, &pressed */, &col, &row)){

						/* If X11 and Caps Lock then release automatically after 20
						 * passes to the emulator core (doesn't X11 suck)..
						 *
						 * We'll only ever receive a pressed event for Caps Lock, so
						 * emulate a release after x amount of time passes within the
						 * emulator core.
						 *
						 * (For games we can use another key, defaults to Windows Left
						 *  key for the moment).
						 */
						if (event.key.keysym.sym == SDLK_CAPSLOCK && cfg_HaveX11){
							 BeebKeyDown(4, 0);
							 X11_CapsLock_Down = 20;
						}else{

							/* Process key in emulator core:
							 */
//							if (pressed)
							if (event.type == SDL_KEYDOWN)
								BeebKeyDown(row, col);
							else
								BeebKeyUp(row, col);
						}
		


//						/* Release Caps lock for X11 after a short delay.
//						 */
//						if (event.key.keysym.sym == SDLK_CAPSLOCK && cfg_HaveX11){
//							printf("Need to release Caps\n");
//							//SDL_Delay(1000);
//							X11_CapsLock_Down = 10;
//						}

						/* Handle reset:
						 */
						if(row==-2){ // Must do a reset!
							Init6502core();
							if (EnableTube)
								Init65C02core();

							if (Tube186Enabled) i86_main();
							Enable_Z80 = 0;
							if (TorchTube || AcornZ80)
								{
								R1Status = 0;
								ResetTube();
								init_z80();
								Enable_Z80 = 1;
							}
							Disc8271_reset();
							Reset1770();
#							ifdef WITH_ECONET
							if (EconetEnabled)
								EconetReset();//Rob
#							endif
							SCSIReset();
							SASIReset();
							TeleTextInit();
							//SoundChipReset();
						}
					}
				}
			}
		
//		/* Execute emulator:
//		 */
//		if (!mainWin->IsFrozen())
//			Exec6502Instruction();

		}else{
			/* Make sure mouse pointer is shown when menu is displayed
			 */
			if (SDL_ShowCursor(SDL_QUERY) != SDL_ENABLE)
				SDL_ShowCursor(SDL_ENABLE);


			/* Process window manager signals:
			 */
			while ( SDL_PollEvent(&event) ){
				switch (event.type)
				{
				case SDL_QUIT:
				done=1;
				break;

#				ifdef WITH_DEBUG_OUTPUT
				/* For now allow exit with ESCAPE.
				 */
				case SDL_KEYDOWN:
				if(event.key.keysym.sym == SDLK_ESCAPE)
					done=1;
				break;
#				endif
				}

				/* Send event to GUI:
				 */
				EG_Window_ProcessEvent(displayed_window_ptr, &event, 0, 0);
			}

//			printf("Menu mode.\n");
			SDL_Delay(50);


			/* Record time so we can hide the mouse cursor after a small delay.
			 */
			ticks = SDL_GetTicks();


		}

//	printf("%d\n", AMXButtons);



//--	} while(1);
	} while(done==0);

//--	mainWin->KillDLLs();

//    	fclose(tlog);

	/* Sometimes the mouse pointer vanishes on exit.
	 * It seems to only happen when fullscreened, so make sure
	 * we unfullscreen before destroying everything.
	 */
	UnfullscreenBeforeExit();

	delete mainWin;
//--	Kill_Serial();

	/* Cleanly free SDL and logging.
	 */
#ifdef WITH_DEBUG_OUTPUT
	DumpFakeRegistry();
#endif

	DestroyFakeRegistry();
	DestroyBeebEmGUI();
	UninitialiseSDL();
	Log_UnInit();

	return(0);  
} /* main */
